if(!dojo._hasResource["com.ibm.mm.builder.widget.ColumnLayoutMoveWidget"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ColumnLayoutMoveWidget"] = true;
dojo.provide("com.ibm.mm.builder.widget.ColumnLayoutMoveWidget");

dojo.require("com.ibm.mm.builder.widget.CustomDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.iwidget.columnlayout.columnUtil");
dojo.require("com.ibm.mm.builder.dialog.DialogFooter");

dojo.declare("com.ibm.mm.builder.widget.ColumnLayoutMoveWidget",[dijit._Widget, dijit._Templated],{	
    templateString: 
    	'<div>'+
			'<div class="columnMoveContent" dojoAttachPoint="containerNode">' +
				'<div class="columnMoveInfo">${I_COLUMN_CONF_MOVEWIDGET_INFO}</div>'+
				'<div class="columnMoveWidgetDiv">'+
					'<table>'+
						'<tr>'+
						 	'<td>'+
								'<span class="moveWidget_item_label">${I_CONTEXT_MENU_COLUMNWIDGET_COLUMN_LABEL}</span>'+
							'</td>'+
							'<td class="columnMoveWidget_column_container">'+					
								'<div dojoType="com.ibm.mm.builder.widget.PaneBoxItemColumnPanel" dojoAttachPoint="widgetColumnPaneBox"></div>'+
							'</td>'+
						'</tr><tr style="height: 10px;"></tr><tr>'+
							'<td class="columnMoveWidget_row_container">'+
								'<span class="moveWidget_item_label">${I_CONTEXT_MENU_COLUMNWIDGET_POSITION_IN_COLUMN_LABEL}</span>'+
							'</td>'+
							'<td class="columnMoveWidget_row_container">'+
								'<div dojoType="com.ibm.mm.builder.widget.PaneBoxItemRowPanel" dojoAttachPoint="widgetRowPaneBox"></div>'+
							'</td>'+
						'</tr>'+
					'</table>'+
				'</div>'+
			'</div>' +
			'<div dojoType="com.ibm.mm.builder.dialog.DialogFooter" dojoAttachPoint="footer" '+
				'dojoAttachEvent="onSave: save, onCancel: hide">'+
		'</div>',
	
	I_COLUMN_CONF_MOVEWIDGET_INFO: com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MOVEWIDGET_INFO,
	I_CONTEXT_MENU_COLUMNWIDGET_COLUMN_LABEL: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_COLUMNWIDGET_COLUMN_LABEL,
	I_CONTEXT_MENU_COLUMNWIDGET_POSITION_IN_COLUMN_LABEL: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_COLUMNWIDGET_POSITION_IN_COLUMN_LABEL,
	I_COMMON_CANCEL: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_CANCEL,
	I_COMMON_SAVE: com.ibm.mm.builder.coreWidgetsStrings.I_COMMON_SAVE,
	
	widgetsInTemplate: true,

	postCreate: function(){	
		this.uniDialog = new com.ibm.mm.builder.widget.CustomDialog(this.dlgPara);
		this.uniDialog.containerNode.appendChild(this.domNode);
		
		dojo.connect(this.uniDialog, "onResize", this, "onDialogResize");
	},
	
	_onKeyPress:function(evt){
		if (evt.keyCode == dojo.keys.ENTER) {
			dojo.stopEvent(evt);
			this.save();
		}
	},
	
	hide: function(){
		this.uniDialog.hide();
	},
	
	updateProperty: function(widgetId){
		this.widgetId = widgetId;
		
		var title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(widgetId);
		var _title = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MOVE_WIDGET_PROMPT, [title]);
		com.ibm.mm.builder.utils.htmlUtil.setNodeTitle(_title,this.movePrompt,300);
		
		var totalColumns = com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum();
		if (totalColumns) {
			 totalColumns = parseInt(totalColumns, 10);
		}
		
		var targetWidget = dojo.byId(widgetId);
		var widgetLayoutDataStr = targetWidget.getAttribute("layoutdata");
		
		dojo.mixin(this.widgetColumnPaneBox, {
			itemNum: totalColumns,
			layoutData: widgetLayoutDataStr
		}).refresh();
		
		dojo.forEach(this.widgetColumnPaneBox.getChildren(), function(child){
			dojo.connect(child, "_onClick", this.widgetRowPaneBox, 
				dojo.partial(this.widgetRowPaneBox.refresh, child.getItemIndex()));
		}, this);
		
		var widgetSourceColumn = widgetLayoutDataStr.substr(widgetLayoutDataStr.indexOf("column:") + 7, 1);
		
		if (widgetSourceColumn) {
			widgetSourceColumn = parseInt(widgetSourceColumn, 10);
		}
        dojo.mixin(this.widgetRowPaneBox, {
            layoutData: widgetLayoutDataStr,
            widgetSourceColumn: widgetSourceColumn,
            widgetId: this.layoutContext.widgetId
        }).refresh(widgetSourceColumn);
		this.uniDialog.show();
	},
	
	setTitle: function(title)
	{
		if(this.uniDialog)
		{
			this.uniDialog.setTitle(title);
		}
	},
		
	save: function(){
		this.moveWidget({
			id: this.widgetId,
			widgetColumn: this.widgetColumnPaneBox.getSelectedItem().getItemIndex(),
			widgetRow: this.widgetRowPaneBox.getSelectedItem().getItemIndex()
		});
		this.hide();
	},
	
    moveWidget: function(widgetInfo){
        var widgetId = widgetInfo.id;
        com.ibm.mm.builder.iwidget.columnlayout.columnUtil.moveWidget(widgetId, 
			widgetInfo.widgetColumn, widgetInfo.widgetRow, this.layoutContext.widgetId);
    },

	onDialogResize: function(width, height)
	{
		var dialogContainerCB = dojo.contentBox(this.uniDialog.containerNode);
		var containerMB = dojo.marginBox(this.containerNode);
		var footerHeight = dojo.marginBox(this.footer.domNode).h;
		
		containerMB.w = dialogContainerCB.w;
		containerMB.h = dialogContainerCB.h - footerHeight;
		
		dojo.marginBox(this.containerNode, containerMB);
	}
});

dojo.declare("com.ibm.mm.builder.widget.PaneBoxItemPanel", [dijit._Widget, dijit._Templated, dijit._Container], {
	templateString: '<div dojoAttachEvent="onkeypress:_onKeyPress" title="${CONTAINER_TITLE}" ></div>',
	
	CONTAINER_TITLE: "",
	
	unselectedAll:function(){
		dojo.forEach(this.getChildren(), function(c){
			c._selectItem(false);
		});
	},
	
	clear: function(){
		dojo.forEach(this.getChildren(), function(c){
			c.destroy();
		});
	},
	
	//to override 
	refresh:function(){},
	
	getSelectedItem:function(){
		return dojo.filter(this.getChildren(), function(item){
			return item.selected;
		})[0];
	}
});

dojo.declare("com.ibm.mm.builder.widget.PaneBoxItem", [dijit._Widget, dijit._Templated, dijit._Contained], {
	
	templateString:
		'<div class="${unselectedClass}" role="button" dojoAttachPoint="containerNode" dojoAttachEvent="onclick: _onClick, onkeypress:_onKeyPress" tabindex=0></div>',
	
	selected: false,
	unselectedClass: "",
	selectedClass: "",
	
	postCreate: function() {
		this._setA11YHint();
	},
	
	_onKeyPress:function(e){
		if (e.keyCode == dojo.keys.ENTER) {
			this._onClick(e);
		}
	},   

   	_selectItem:function(flag){
   		if (flag) {
			this.getParent().unselectedAll();
		}
		this.selected = flag;
		dojo.toggleClass(this.containerNode, this.unselectedClass, !flag);
		dojo.toggleClass(this.containerNode, this.selectedClass, flag);
		this._setA11YHint();
   	},
	
   	_onClick: function(e){
   		this._selectItem(true);
	},
	
	getItemIndex:function(){
		return this.itemIndex;
	},
	
	_setA11YHint: function() {
		if (this.selected) {
			var selectedColumnTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MOVEWIDGET_SELECTED_COLUMN_INFO_1, [this.itemIndex]);
			dojo.attr(this.containerNode, "title", selectedColumnTitle);
		} else {
			var columnTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MOVEWIDGET_COLUMN_INFO_1, [this.itemIndex]);
			dojo.attr(this.containerNode, "title", columnTitle);
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.PaneBoxItemColumnPanel", [com.ibm.mm.builder.widget.PaneBoxItemPanel], {
	
	CONTAINER_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_COLUMNWIDGET_COLUMN_LABEL,
	
	_onKeyPress:function(e){
		switch(e.keyCode){
			case dojo.keys.ESCAPE:
			   this.getChildren()[this.currItemNum-1]._onClick(e);
			   dojo.stopEvent(e);
			   break;
			case dojo.keys.ENTER:
				this.refreshRow(e);
			   break;
			case dojo.keys.LEFT_ARROW:
			   //this.previousItem(e);
			   break;
			case dojo.keys.RIGHT_ARROW:
			   //this.nextItem(e);
			   break;
		}
	},

	refreshRow:function(e){
		var selectedItem = this.getSelectedItem(); 		
		var currentItemIndex = selectedItem.getItemIndex()-1;
		this.getChildren()[currentItemIndex]._onKeyPress(e);
	},
	
	previousItem:function(e){
		var selectedItem = this.getSelectedItem(); 
		if(selectedItem.getItemIndex()==1){
			return;
		}
		var targetItemIndex = selectedItem.getItemIndex()-2;
		this.getChildren()[targetItemIndex]._selectItem(true);
	},
	
	nextItem:function(e){
	    var selectedItem = this.getSelectedItem(); 
		if(selectedItem.getItemIndex()==this.itemNum){
			return;
		}
		var targetItemIndex = selectedItem.getItemIndex();
		this.getChildren()[targetItemIndex]._selectItem(true);
	},
	
	refresh:function(){
		this.clear();
		
        dojo.addClass(this.domNode, "columnMoveWidget_column_container");
        if (builderConfig.isBidi) {
            dojo.addClass(this.domNode, "columnMoveWidget_column_container_" + this.itemNum);
        }
		this.currItemNum = this.layoutData.substr(this.layoutData.indexOf("column:") + 7, 1);
		if (this.currItemNum){
			this.currItemNum = parseInt(this.currItemNum,10);	
		}
        for (var i = 0; i < this.itemNum; i++) {
            var columnNumber = builderConfig.isBidi ? this.itemNum - i : i + 1;
            this.addChild(new com.ibm.mm.builder.widget.ColumnPaneBoxItem({
                itemIndex: i + 1,
                layoutData: this.layoutData,
                title: dojo.string.substitute(
					com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_COLUMNWIDGET_COLUMN_PANEBOX_TITLE, [columnNumber])
            }));
        }
        this.getChildren()[this.currItemNum - 1]._selectItem(true);
	}
});

dojo.declare("com.ibm.mm.builder.widget.ColumnPaneBoxItem", [com.ibm.mm.builder.widget.PaneBoxItem], {
	selectedClass: "columnMoveWidget_column_box_selected",
	unselectedClass: "columnMoveWidget_column_box_unselected"
});

dojo.declare("com.ibm.mm.builder.widget.PaneBoxItemRowPanel", [com.ibm.mm.builder.widget.PaneBoxItemPanel], {
	
	CONTAINER_TITLE: com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_COLUMNWIDGET_POSITION_IN_COLUMN_LABEL,
	
	_onKeyPress:function(e){
		switch(e.keyCode){
			case dojo.keys.ESCAPE:
			   this.getChildren()[this.widgetSourceColumn-1]._onClick(e);
			   dojo.stopEvent(e);
			   break;
			case dojo.keys.UP_ARROW:
			   this.previousItem(e);
			   dojo.stopEvent(e);
			   break;
			case dojo.keys.DOWN_ARROW:
			   this.nextItem(e);
			   dojo.stopEvent(e);
			   break;		
		}
	},
	
	previousItem:function(e){
		var selectedItem = this.getSelectedItem(); 
		if(selectedItem.getItemIndex()==1){
			return;
		}
		var targetItemIndex = selectedItem.getItemIndex()-2;
		this.getChildren()[targetItemIndex]._onClick(e);
	},
	
	nextItem:function(e){
	    var selectedItem = this.getSelectedItem(); 
		if(selectedItem.getItemIndex()==this.rowPaneBoxNum){
			return;
		}
		var targetItemIndex = selectedItem.getItemIndex();
	    this.getChildren()[targetItemIndex]._onClick(e);
	},   
	
	refresh:function(targetColumnNum){
		this.clear();
		
		var targetCol = dojo.byId("_" + this.widgetId + "_Column" + targetColumnNum);
		var targetColWidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,targetCol);
		this.widgetsNumInTargetCol = targetColWidgets.length;
		
		this.currItemRowNum = this.layoutData.substr(this.layoutData.indexOf("row:") + 4, 1);
		if (this.currItemRowNum){
			this.currItemRowNum = parseInt(this.currItemRowNum,10);	
		}
		
		this.rowPaneBoxNum = targetColumnNum == this.widgetSourceColumn ? this.widgetsNumInTargetCol : 
			this.widgetsNumInTargetCol+1;
			
		var totalColumns = com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum();
		if(totalColumns){
		   totalColumns = parseInt(totalColumns,10);
		}
        for (var i = 0; i < this.rowPaneBoxNum; i++) { // i is the row
            var columnNumber = builderConfig.isBidi ? totalColumns - parseInt(targetColumnNum,10) + 1 :
				targetColumnNum;

            this.addChild(new com.ibm.mm.builder.widget.RowPaneBoxItem({
                itemIndex: i + 1,
                layoutData: this.layoutData,
				title: dojo.string.substitute(
					com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_COLUMNWIDGET_POSITION_IN_COLUMN_PANEBOX_TITLE, 
					[i + 1, columnNumber])
            }));
        }
		this.getChildren()[targetColumnNum == this.widgetSourceColumn ? 
			this.currItemRowNum-1 : 0]._selectItem(true);
	}
});

dojo.declare("com.ibm.mm.builder.widget.RowPaneBoxItem", [com.ibm.mm.builder.widget.PaneBoxItem], {
	selectedClass: "columnMoveWidget_row_box_selected",
	unselectedClass: "columnMoveWidget_row_box_unselected",
	_setA11YHint: function() {
		if (this.selected) {
			var selectedRowTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MOVEWIDGET_SELECTED_ROW_INFO_1, [this.itemIndex]);
			dojo.attr(this.containerNode, "title", selectedRowTitle);
		} else {
			var rowTitle = dojo.string.substitute(com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MOVEWIDGET_ROW_INFO_1, [this.itemIndex]);
			dojo.attr(this.containerNode, "title", rowTitle);
		}
	}
});

}
